class TutButton  {
	
	int x, y, w, h;
	int numStates, state;
  int[] vertTextOffsetArray;

	color textColor, minorTextColor, backgroundColor, highlightColor;
  color shadowColor;

	String[] mainText;

  boolean clickInstructions = false;
  boolean creditText = false;
  boolean progressNumbers = true;
  boolean boldText = false;
  int creditState = 0;
  //boolean showThisTut = true;

  PFont[] tutFontArray;
  int[] tutLeadingArray;



  TutButton(int x_, int y_, int w_, int h_, int numStates_){ 
  x=x_;
  y=y_;
  w=w_;
  h=h_;

  numStates = numStates_;
  state = 0;

  mainText = new String[numStates];

  tutFontArray = new PFont[numStates];
  tutLeadingArray = new int[numStates];
   vertTextOffsetArray = new int[numStates];

  for (int i =0; i < numStates; i++){
    tutFontArray[i] = tutFont;
    tutLeadingArray[i] = 17;
  }






}


void display(){

    noStroke();
    if (over()){
    	fill(highlightColor);
    } else {
    	fill(backgroundColor);
    }
    rect(x,y,w,h);

 
   

    textAlign(LEFT);
    //textFont(tutFont);
    textFont(tutFontArray[state]);
    textLeading(tutLeadingArray[state]);

    if (boldText==true && state==0){
      fill(shadowColor);
      //text(mainText[state], x+5, y+4 + vertTextOffsetArray[state], w-4, h+20);
    }
     fill(textColor);
    text(mainText[state], x + 4, y + 4 + vertTextOffsetArray[state], w -4, h + 20);


    if (clickInstructions == true) {
      fill(minorTextColor);
      textAlign(LEFT, BOTTOM);
      textFont(mainFont);
      text("Left click to advance, right click to go back.", x+4, y, w, h);
    }

    if(creditText == true && state == creditState) {
      fill(minorTextColor);
      textAlign(RIGHT, TOP);
      textFont(mainFont);
      text("by Steve Kranz, 2014", x+w-10, y+5);
    }

    if(progressNumbers==true){
    fill(minorTextColor);
    textAlign(RIGHT, BOTTOM);
    textFont(tutNumFont);
    text(str(state+1) + "/" + numStates, x, y, w - 4, h); // make that "state + 1" when released to public....
   }

  }




void update(){

      // count is reset to zero when the mouseButton is released.
     if (count == 0){
       if (over() == true) {
         if (mousePressed == true && mouseButton == LEFT) {
                 toggleUp();
                 count++;
             }
          if (mousePressed == true && mouseButton == RIGHT){
            toggleDown();
            count++;
          }


         }
     }    

   if (backgroundBang.state == 0){
    textColor = color(0,0,0);
    shadowColor = color(0,0,0);
    minorTextColor = color (0,0, 50);
    backgroundColor = color(0,0,92);
    highlightColor = color(0,0,87);
  } else {
    textColor = color(0,0,100);
    shadowColor = color(0,0,0);
    minorTextColor = color(0,0,70);
    backgroundColor = color(0,0,20);
    highlightColor = color(0,0,30);
  }
 
   if (showTut){
  display();
}

}



  
          



    void toggleUp(){
        state = (state+1) % numStates; 
        //toggleCount++;
    }

    void toggleDown(){
         state = (state-1);
         if (state < 0){
          state = numStates -1;
         }
    }

void setState(int i, String pageText){
  mainText[i] = pageText;
}

void setFont(PFont font_, int leading_, int vertTextOffset_, int i){
  tutFontArray[i] = font_;
  tutLeadingArray[i] = leading_;
  vertTextOffsetArray[i] = vertTextOffset_;
}


boolean over() 
{
 if (mouseX >= x && mouseX <= x + w && mouseY >= y && mouseY <= y + h)
 {
 	return true;
 } else {
 	return false;
 }
} // end over()


}

