// 

class BangButton {

    
    int x, y, w, h;
String offText, onText, label;
String helpText = "";
String helpTitleText = "";

boolean isItOn = true;
boolean flashing = false;
boolean visible = true;

color offColor;
color offTextColor; 

Flash buttonFlash;


    int state = 0;
    int numStates;
    int toggleCount = 0;

    float[] values;
    String[] stateNames;
    color[] backgroundColors;
    color[] textColors;

        color onColor;
        color onTextColor;
        color labelColorBang;





    BangButton(int x_, int y_, int w_, int h_, String label_, int numStates_){
        
            x = x_;
            y = y_;
            w = w_;
            h = h_;
     
           label = label_;
        numStates = numStates_;

        values = new float[numStates];
        stateNames = new String[numStates];
        backgroundColors = new color[numStates];
        textColors = new color[numStates];

         onColor = color(0, 0, 20);
         onTextColor = color(0, 0, 92);
         labelColorBang = color(0, 0, 50);

          offColor = onTextColor;
          offTextColor = onColor; 

          buttonFlash = new Flash(x, y, w, h, 4, 50, 100, 100);

    }


     void update() {

        // count is reset to zero when the mouseButton is released.
        if (count == 0){
         if (over() == true) {
             if (mousePressed == true) {
     
                 toggle();
                 count++;
             }
         }
     }      
             display(); 
             flashing = false; 
             visible = true;        
     }


    void toggle(){
        state = (state+1) % numStates;
        toggleCount++;
    }

    void display() {

     textFont(mainFont);

      if (visible == true){
        noStroke();
        fill(backgroundColors[state]);
        rect (x, y, w, h);
        
        if(flashing==true){
        buttonFlash.display();
        }


        textAlign(CENTER);
        fill(textColors[state]);
        text(stateNames[state], x+int(w/2), y+int(h*0.75));
        fill(labelColorBang);
        textAlign(LEFT);
        text(label, x+w+5, y+int(h*0.75));

        if(over() &&  helpBang.state==1){
         drawToolTip();
        }

      }

    }

    // inherit void update() from ToggleButton class.
    
    void setState(int state_, float value_, String stateName_, color backgroundColor_, color textColor_){
      values[state_] = value_;
      stateNames[state_] = stateName_;
      backgroundColors[state_] = backgroundColor_;
      textColors[state_] = textColor_;

    }

    void setLabelColor(color labelColor_){
        labelColorBang = labelColor_;
    }

    float returnValue(){
        return values[state];
    }

  boolean over() {
     if (mouseX >= x && mouseX <= x + w && mouseY >= y && mouseY <= y + h)
     {
        return true;
     } else {
        return false; 
     }
} // end over()


void setValue(int s_){
   if (s_ > numStates-1) { state = numStates-1;}
   if (s_ < 0) {state = 0;}

   state = s_;
}



void flashOn(){
    flashing = true;
}

void hide(){
    visible = false;
}

void setHelpText(String helpTitleText_, String helpText_){
    helpTitleText = helpTitleText_;
    helpText = helpText_;
}


void drawToolTip(){

if (backgroundBang.state==0){
    fill(0,0,80);
} else {
    fill(0,0,40);
}

textFont(helpTitleFont);
textAlign(LEFT, TOP);
text(helpTitleText, helpX + 10, helpY, helpW - 10, helpH);

float titleWidth = textWidth(helpTitleText); 

if (backgroundBang.state==0){
    fill(0,0,0);
} else {
    fill(0,0,100);
}

textFont(helpFont);
textAlign(LEFT, TOP);
textLeading(16);
text(helpText, helpX + titleWidth + 25 ,helpY + 4,helpW - titleWidth - 25 - 10, helpH );

}


}
